package sun.nio.ch;

import java.io.IOException;
import java.io.FileDescriptor;

abstract class NativeDispatcher
{
    NativeDispatcher() {
    }
    
    abstract int read(FileDescriptor p0, long p1, int p2) throws IOException;
    
    boolean needsPositionLock() {
        return false;
    }
    
    int pread(FileDescriptor fileDescriptor, long n, int n2, long n3) throws IOException {
        throw new IOException("Operation Unsupported");
    }
    
    abstract long readv(FileDescriptor p0, long p1, int p2) throws IOException;
    
    abstract int write(FileDescriptor p0, long p1, int p2) throws IOException;
    
    int pwrite(FileDescriptor fileDescriptor, long n, int n2, long n3) throws IOException {
        throw new IOException("Operation Unsupported");
    }
    
    abstract long writev(FileDescriptor p0, long p1, int p2) throws IOException;
    
    abstract void close(FileDescriptor p0) throws IOException;
    
    void preClose(FileDescriptor fileDescriptor) throws IOException {
    }
}
